var currentlySelectedFeature, jsonLayer, mapControl;


// Simple JavaScript Templating
// John Resig - http://ejohn.org/ - MIT Licensed
(function(){
  var cache = {};
 
  this.tmpl = function tmpl(str, data){
    // Figure out if we're getting a template, or if we need to
    // load the template - and be sure to cache the result.
    var fn = !/\W/.test(str) ?
      cache[str] = cache[str] ||
        tmpl(document.getElementById(str).innerHTML) :
     
      // Generate a reusable function that will serve as a template
      // generator (and which will be cached).
      new Function("obj",
        "var p=[],print=function(){p.push.apply(p,arguments);};" +
       
        // Introduce the data as local variables using with(){}
        "with(obj){p.push('" +
       
        // Convert the template into pure JavaScript
        str
          .replace(/[\r\t\n]/g, " ")
          .split("<%").join("\t")
          .replace(/((^|%>)[^\t]*)'/g, "$1\r")
          .replace(/\t=(.*?)%>/g, "',$1,'")
          .split("\t").join("');")
          .split("%>").join("p.push('")
          .split("\r").join("\\'")
      + "');}return p.join('');");
   
    // Provide some basic currying to the user
    return data ? fn( data ) : fn;
  };
})();


$(function() {
  var center = new OpenLayers.LonLat(72.855211097628413, 19.010775291486027);
  map = new OpenLayers.Map('map');
  var layers = [];
  layers[0] = new OpenLayers.Layer.Google(
                "Google Streets", // the default
                {numZoomLevels: 20, isBaseLayer: true}
            );
  geojson_format = new OpenLayers.Format.GeoJSON();
  //yes, jsonLayer is global. Yes, I know it's wrong.
/*
  var symbolizer = OpenLayers.Util.applyDefaults(
        {fillColor: 'green', opacity: 0.5, strokeColor: '#000', cursor: 'pointer'},
        OpenLayers.Feature.Vector.style["default"]);
  defaultStyles = new OpenLayers.StyleMap({"default": symbolizer, "selected": symbolizer});
*/
  jsonLayer = layers[1] = new OpenLayers.Layer.Vector({'geometryType': 'Point'});
//  map.addLayer(vector_layer);
  map.addLayers(layers);
  map.setCenter(center, 12);

  mapControl = new OpenLayers.Control.SelectFeature(layers[1], {hover: false}); 
  map.addControl(mapControl);
  mapControl.activate();
  layers[1].events.on({
    'featureselected': onFeatureSelect
  });  
});


function onFeatureSelect(f) {
  $.noop();
/*
  var id = f.feature.attributes.id;
  $.getJSON("flyover", {'id': id}, function(json) {
    $('#media').html(json.name + "<br /><br />");
    $.each(json.media.images, function(i, v) {
      var img = $('<img />').attr("src", v.url).css({'width': '100px', 'height': '100px'});
      $('#media').append(img);
    });
  });
*/
}


//will highlight the feature id's passed in arr
function highlightFeatures(arr) {
  var features = jsonLayer.features;
  for (var f in features) {
    if (features.hasOwnProperty(f)) {
      if ($.inArray(features[f].attributes.id, arr) != -1) {
        features[f].attributes.highlighted = 1;        
        } else {
        features[f].attributes.highlighted = 0;
        }
      }
    }
  highlightSelected();
  }

//Function to actually highlight features marked with highlighted = 1
function highlightSelected() {
//  alert("foo");
  var lookup = {
    0: {opacity: 0.3, strokeWidth: 0.4},
    1: {opacity: 1, strokeWidth: 3, strokeOpacity: 0.6, strokeColor: '#5B00FF'}
    }
//  console.log(defaultStyles);
  defaultStyles.addUniqueValueRules("default", "highlighted", lookup);
  jsonLayer.redraw();
//  console.log(jsonLayer);
  return true;
  }

//When user mouses over an image, highlight that point on the map.
function mouseOverImage(id) {
  var features = jsonLayer.features;
  for (var f in features) {
    if (features.hasOwnProperty(f)) {
      if (features[f].attributes.id == id) {
        features[f].attributes.mousedover = 1;
        } else {
        features[f].attributes.mousedover = 0;
        }
      }
    }
  var lookup = {
    0: {opacity: 0.3},
    1: {strokeWidth: 6, strokeColor: '#1E90FF', strokeOpacity: 0.9}
    }
  defaultStyles.addUniqueValueRules("default", "mousedover", lookup);
  jsonLayer.redraw();  
  }

$(function() {
  $('td').click(function() {
    $('td').removeClass('selected');
    var catName = $(this).text();
    var type = $(this).attr("class").replace("Category", "");
    $(this).addClass('selected');
    var id = $(this).attr("data-id");
    $('#media').html("Loading images for " + catName + " .. please wait..");
    $.getJSON("category", {'id': id, 'type': type}, function(json) {
//      alert(type);
      var arr = [];
      var features = json.flyovers;
      var currFeatures = jsonLayer.features;
      jsonLayer.removeFeatures(currFeatures);
      jsonLayer.addFeatures(geojson_format.read(features));
      alert(type);
      switch(type.toLowerCase()) {
        case "image":
          var html = tmpl("tmpl_images", {'images': json.images});      
          $('#media').html(html);
          $('.imageWrapper a').colorbox();
          break;
        case "video":
          var html = tmpl("tmpl_videos", {'videos': json.videos});
          $('#media').html(html);
          var i = 0;
          $('.videoWrapper').each(function() {
            var videoData = json.videos[i];
            $(this).data("videoData", videoData);
            i++;
          });
          $('.videoWrapper > a').click(function(e) {
            e.preventDefault();
            var data = $(this).closest(".videoWrapper").data("videoData");
            var embedCode = data.info.embed;
            $.colorbox({html: embedCode});
          });
        default:
          $.noop();
      }  
    });
  });
});

function getFlyoverById(id) {
  var features = jsonLayer.features;
  for (var i=0; i < features.length; i++) {
    if (features[i].attributes.id == id) {
      return features[i];
    }
  }  
  return false;
}

$('.flyoverImage').live("mouseover", function() {
  var id = $(this).attr("data-id");
//  console.log(id);
  var flyover = getFlyoverById(id);
  mapControl.select(flyover);
  currentlySelectedFeature = flyover;
});

$('.flyoverImage').live("mouseout", function() {
  mapControl.unselect(currentlySelectedFeature);  
});
